package ctbrec.ui.action;

import java.util.Optional;

import ctbrec.Config;
import ctbrec.Model;
import ctbrec.ui.JavaFxModel;
import ctbrec.ui.controls.Dialogs;
import javafx.application.Platform;
import javafx.scene.Cursor;
import javafx.scene.Node;
import javafx.scene.control.TableView;

public class EditNotesAction {

    private Node source;
    private Model model;
    private TableView<JavaFxModel> table;

    public EditNotesAction(Node source, Model selectedModel, TableView<JavaFxModel> table) {
        this.source = source;
        this.model = selectedModel;
        this.table = table;
    }

    public void execute() {
        source.setCursor(Cursor.WAIT);
        new Thread(() -> {
            Platform.runLater(() -> {
                String notes = Config.getInstance().getSettings().modelNotes.getOrDefault(model.getUrl(), "");
                Optional<String> newNotes = Dialogs.showTextInput("Model Notes", "Notes for " + model.getName(), notes);
                newNotes.ifPresent(n -> Config.getInstance().getSettings().modelNotes.put(model.getUrl(), n));
                table.refresh();
                source.setCursor(Cursor.DEFAULT);
            });
        }).start();
    }
}
